; to use in gamemode 14 or level

!FreeRAM      = $0F5E       ; 10 bytes

main:
       LDA $9D              ;\
       ORA $13D4            ; | return if sprites locked
       BNE .Return          ;/

       LDX #$09             ; check 9 slots
.loop
       STX $15E9            ; store index
       LDA $170B,x          ;\ branch if slot taken
       BNE .Update          ;/
.CheckNext
       DEX                  ;\ loop otherwise
       BPL .loop            ;/
.Return
       RTL                  ; change to rts to use with the patch

.Update
       LDY !FreeRAM,x          ;\ don't process unreflected projectiles
       BEQ .CheckNext       ;/
       CMP #$06             ;\ slots 0 to 5 don't matter, both update
       BCC .CheckNext       ;/ x and y speed
       BEQ Yspeed           ; bone, update y
       CMP #$0E             ;\ don't process slots 0e+
       BCS .CheckNext       ;/
       CMP #$0D             ;\ baseball, update y
       BEQ Yspeed           ;/
       CMP #$08             ;\ launcher arm, update x
       BEQ Xspeed           ;/

Xspeed:
       PHK
       PEA.w .Return-1
       PEA.w $02B889-1
       JML $02B554
.Return
       BRA Offscreen

Yspeed:
       PHK
       PEA.w .Return-1
       PEA.w $02B889-1
       JML $02B560
.Return

Offscreen:
       LDA $171F,x
       SEC
       SBC $1462
       LDA $1733,x
       SBC $1463
       BNE .Clear
       LDA $1715,x
       SEC
       SBC $1464
       LDA $1729,x
       SBC $1465
       BEQ main_CheckNext
.Clear
       STZ !FreeRAM,x
       STZ $173D,x
       STZ $1747,x
       STZ $170B,x
       BRA main_CheckNext

